unit main;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls, ComCtrls, ExtCtrls,
	Menus,
	ImgList,
	ToolWin,
	DirectShow9;

const
	//Cxg󂯎邽߂̃j[NȃbZ[Wԍ
	WM_GRAPH_NOTIFY = (WM_APP +1);

type
	TForm1 = class(TForm)
		MainMenu1:           TMainMenu;
		MenuItem_File:       TMenuItem;
		MenuItem_FileOpen:   TMenuItem;
		MenuItem_FileLine1:  TMenuItem;
    MenuItem_ListDelete: TMenuItem;
		MenuItem_ListClear:  TMenuItem;
		MenuItem_FileLine2:  TMenuItem;
		MenuItem_FileExit:   TMenuItem;
		MenuItem_Play:       TMenuItem;
		MenuItem_PlayPause:  TMenuItem;
		MenuItem_PlayStop:   TMenuItem;
		MenuItem_PlayLine1:  TMenuItem;
		MenuItem_PlayBack:   TMenuItem;
		MenuItem_PlayNext:   TMenuItem;
		MenuItem_PlayLine2:  TMenuItem;
		MenuItem_FrameBack:  TMenuItem;
		MenuItem_FrameNext:  TMenuItem;
		MenuItem_PlayLine3:  TMenuItem;
		MenuItem_Rate:       TMenuItem;
		MenuItem_Rate_20:    TMenuItem;
		MenuItem_Rate_15:    TMenuItem;
		MenuItem_Rate_13:    TMenuItem;
		MenuItem_Rate_11:    TMenuItem;
		MenuItem_Rate_10:    TMenuItem;
		MenuItem_Rate_09:    TMenuItem;
		MenuItem_Rate_07:    TMenuItem;
		MenuItem_Rate_05:    TMenuItem;
		MenuItem_Rate_03:    TMenuItem;
		MenuItem_Rate_01:    TMenuItem;
		MenuItem_Rate_17:    TMenuItem;
		MenuItem_Video:      TMenuItem;
		MenuItem_KeepAspect: TMenuItem;
		MenuItem_VideoLine1: TMenuItem;
		MenuItem_Capture:    TMenuItem;
		MenuItem_Opt:        TMenuItem;
		MenuItem_Event:      TMenuItem;
		ComboBox1:         TComboBox;
		TrackBar1:         TTrackBar;
		Panel_Video:       TPanel;
		Panel_Control:     TPanel;
		ToolBar1:          TToolBar;
		Button_PlayPause:  TToolButton;
		Button_Stop:       TToolButton;
		Button_PlayBack:   TToolButton;
		Button_PlayNext:   TToolButton;
		Button_Spc1:       TToolButton;
		Button_Capture:    TToolButton;
		Button_KeepAspect: TToolButton;
		Button_FrameBack:  TToolButton;
		Button_FrameNext:  TToolButton;
		Button_Spc2:       TToolButton;
		Label_Size:        TLabel;
		Label_Time:        TLabel;
		ImageList1:        TImageList;
		Timer1:            TTimer;
		OpenDialog1:       TOpenDialog;

		procedure FormCreate (Sender: TObject);
		procedure FormDestroy(Sender: TObject);
		procedure MenuItem_FileExitClick  (Sender: TObject);
		procedure Button_OpenClick        (Sender: TObject);
		procedure Button_DeleteClick      (Sender: TObject);
		procedure Button_ClearClick       (Sender: TObject);
		procedure Button_PlayPauseClick   (Sender: TObject);
		procedure Button_PlayClick        (Sender: TObject);
		procedure Button_PauseClick       (Sender: TObject);
		procedure Button_StopClick        (Sender: TObject);
		procedure Button_PlayBackClick    (Sender: TObject);
		procedure Button_PlayNextClick    (Sender: TObject);
		procedure Button_FrameNextClick   (Sender: TObject);
		procedure Button_CaptureClick     (Sender: TObject);
		procedure ComboBox1Select         (Sender: TObject);
		procedure TrackBar1Change         (Sender: TObject);
		procedure Timer1Timer             (Sender: TObject);
		procedure CheckBox_KeepAspectClick(Sender: TObject);
		procedure Panel_VideoResize       (Sender: TObject);
		procedure Panel_VideoDblClick     (Sender: TObject);
		procedure Button_FrameBackClick(Sender: TObject);
    procedure MenuItem_Rate_10Click(Sender: TObject);
		procedure FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
	private
		{ Private 錾 }
		F_GraphBuilder     : IGraphBuilder;
		F_MediaEventEx     : IMediaEventEx;
		F_MediaPosition    : IMediaPosition;
		F_VideoRenderer    : IBaseFilter;
		F_AudioRenderer    : IBaseFilter;
		F_fDuration        : TRefTime;
		F_fAvgTimePerFrame : Double;
		F_iVideoWidth      : Integer;
		F_iVideoHeight     : Integer;
		F_sFileName        : WideString;

		//Cxgʒm̂߂̃bZ[Wԍ󂯎悤ɂ
		procedure WMGraphNotify  (var Msg: TMessage); message WM_GRAPH_NOTIFY;
		//fBXvCݒ̕ύX
		procedure WMDisplayChange(var Msg: TMessage); message WM_DISPLAYCHANGE;
		procedure F_Close;
		function  F_GetFrameRate : String;
		function  F_CanStep(iStep: Integer): Boolean;
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

procedure DisconnectFilters(AGraphBuilder : IGraphBuilder);
procedure DisconnectPins(ABaseFilter : IBaseFilter);
function  GetUnconnectedPin(pFilter : IBaseFilter; PinDir : PIN_DIRECTION; var ppPin : IPin) : HResult;
function  ConnectFilters(pGraph : IGraphBuilder; pOut : IPin;        pDest : IBaseFilter) : HResult; overload;
function  ConnectFilters(pGraph : IGraphBuilder; pSrc : IBaseFilter; pDest : IBaseFilter) : HResult; overload;
function  CreateBaseFilter(var ABaseFilter : IBaseFilter; ACategory : TGUID; sFriendryName : WideString) : HResult;

implementation
uses
	ActiveX,
	BaseClass,
	CommCtrl,
	DSUtil,
	capt,      //Lv`p
	debug_msg; //fobOo͗p

{$R *.dfm}


//------------------------------------------------------------------------------
//ėp[`
procedure DisconnectFilters(AGraphBuilder : IGraphBuilder);
//Ot̃tB^[ׂ̂Ẵs̐ڑ؂B
var
	l_MediaControl : IMediaControl;
	l_EnumFilters  : IEnumFilters;
	l_BaseFilter   : IBaseFilter;
begin
	if (AGraphBuilder = nil) then begin
Exit;
	end;

	AGraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
	l_MediaControl.Stop;
	l_MediaControl := nil;

	AGraphBuilder.EnumFilters(l_EnumFilters);
	while (l_EnumFilters.Next(1, l_BaseFilter, nil) = S_OK) do begin
		DisconnectPins(l_BaseFilter);
		l_BaseFilter := nil;
	end;
	l_EnumFilters  := nil;
end;

procedure DisconnectPins(ABaseFilter : IBaseFilter);
//tB^[ׂ̂Ẵs̐ڑ؂B
var
//	li_Ret     : HResult;
	l_EnumPins : IEnumPins;
	l_Pin      : IPin;
	l_ToPin    : IPin; //ڑ̃sB
begin
	if (ABaseFilter = nil) then begin
Exit;
	end;

	ABaseFilter.EnumPins(l_EnumPins);
	if (l_EnumPins = nil) then begin
Exit;
	end;

	while (l_EnumPins.Next(1, l_Pin, nil) = S_OK) do begin
		l_Pin.ConnectedTo(l_ToPin);
		if (l_ToPin <> nil) then begin
			l_ToPin.Disconnect;
			l_ToPin := nil;
		end;
		l_Pin.Disconnect;
		l_Pin := nil;
	end;
	l_EnumPins := nil;
end;

function GetUnconnectedPin(pFilter : IBaseFilter; PinDir : PIN_DIRECTION; var ppPin : IPin) : HResult;
//http://msdn.microsoft.com/ja-jp/library/cc973418.aspx
var
	li_Ret     : HResult;
	pEnum      : IEnumPins;
	pPin       : IPin;
	pTmp       : IPin;
	ThisPinDir : TPinDirection ;
begin
	ppPin := nil;
	pEnum := nil;
	pPin  := nil;
	li_Ret := pFilter.EnumPins(pEnum);
	if (FAILED(li_Ret)) then begin
		Result := li_Ret;
Exit;
	end;

	while (pEnum.Next(1, pPin, nil) = S_OK) do begin
		pPin.QueryDirection(ThisPinDir);
		if (ThisPinDir = PinDir) then begin
			pTmp   := nil;
			li_Ret := pPin.ConnectedTo(pTmp);
			if (SUCCEEDED(li_Ret)) then begin
				// ɐڑς݁AKvȃsł͂ȂB
				pTmp := nil;
			end else begin
				// ڑAꂪKvȃsłB
				pEnum  := nil;
				ppPin  := pPin;
				Result := S_OK;
Exit;
			end;
		end;
		pPin := nil;
	end;
	pEnum := nil;
	// vsȂB
	Result := E_FAIL;
end;

function ConnectFilters(
		pGraph : IGraphBuilder; // tB^ Ot }l[WB
		pOut   : IPin;          // AbvXg[ tB^̏o̓sB
		pDest  : IBaseFilter    // _EXg[ tB^B
) : HResult;
//http://msdn.microsoft.com/ja-jp/library/cc973418.aspx
var
{$DEFINE DEBUG}
{$IFDEF DEBUG}
	PinDir : TPinDirection;
{$ENDIF}
	pIn    : IPin;
begin
	if (pGraph = nil)
	or (pOut   = nil)
	or (pDest  = nil)
	then begin
		Result := E_POINTER;
Exit;
	end;

	pOut.QueryDirection(PinDir);
	if (PinDir <> PINDIR_OUTPUT) then begin
		Result := E_FAIL;
Exit;
	end;

	// _EXg[ tB^̓̓sB
	pIn    := nil;
	Result := GetUnconnectedPin(pDest, PINDIR_INPUT, pIn);
	if (FAILED(Result)) then begin
Exit;
	end;

	// ڑB
	Result := pGraph.Connect(pOut, pIn);
	pIn    := nil;
end;

function ConnectFilters(
	pGraph : IGraphBuilder;
	pSrc   : IBaseFilter;
	pDest  : IBaseFilter
) : HResult;
//http://msdn.microsoft.com/ja-jp/library/cc973418.aspx
var
	pOut : IPin;
begin
	if (pGraph = nil)
	or (pSrc   = nil)
	or (pDest  = nil)
	then begin
		Result := E_POINTER;
Exit;
	end;

	// ŏ̃tB^̏o̓sB
	pOut   := nil;
	Result := GetUnconnectedPin(pSrc, PINDIR_OUTPUT, pOut);
	if (FAILED(Result)) then begin
Exit;
	end;

	Result := ConnectFilters(pGraph, pOut, pDest);
	pOut   := nil;
end;

function CreateBaseFilter(var ABaseFilter : IBaseFilter; ACategory : TGUID; sFriendryName : WideString) : HResult;
//o^tB^
//http://msdn.microsoft.com/ja-jp/library/cc371168.aspx
//http://msdn.microsoft.com/ja-jp/library/cc353921.aspx
//http://www.geekpage.jp/programming/directshow/list-capture-device-2.php
//http://miraiware.net/memo/dshow-device.html
var
	l_CreateDevEnum : ICreateDevEnum;
	l_EnumMoniker   : IEnumMoniker;
	l_Moniker       : IMoniker;
	l_PropertyBag   : IPropertyBag;
	l_varName       : OleVariant;
	ls_Name         : WideString;
begin
	Result := CoCreateInstance(
		CLSID_SystemDeviceEnum,
		nil,
		CLSCTX_INPROC_SERVER,
		IID_ICreateDevEnum,
		l_CreateDevEnum
	);
	if (FAILED(Result)) then begin
Exit;
	end;

	try
		Result := l_CreateDevEnum.CreateClassEnumerator(ACategory, l_EnumMoniker, 0);
		if (Result <> S_OK) then begin
Exit;
		end;
		//jJ񋓂B
		while(l_EnumMoniker.Next(1, l_Moniker, nil) = S_OK) do begin
			try
				Result := l_Moniker.BindToStorage(nil, nil, IID_IPropertyBag, l_PropertyBag);
				if (Succeeded(Result)) then begin
					// tB^̃th擾ɂ́ȀsB
					VariantInit(l_varName);
					l_PropertyBag.Read('FriendlyName', l_varName, nil);
					ls_Name := WideString(l_varName);
					VariantClear(l_varName);
					if (WideUpperCase(ls_Name) = WideUpperCase(sFriendryName)) then begin
						//tB^쐬B
						Result := l_Moniker.BindToObject(nil, nil, IID_IBaseFilter, ABaseFilter);
Exit;
					end;
				end;
			finally
				l_PropertyBag := nil;
				l_Moniker     := nil;
			end;
		end;
		//tB^쐬ꂽꍇ͓rExit̂łɗꍇ͍쐬sł̂E_FailԂB
		Result := E_FAIL;
	finally
		l_EnumMoniker   := nil;
		l_CreateDevEnum := nil;
	end;
end;
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
	Label_Size.Caption := '';
	Label_Time.Caption := '';
{
	//Ot쐬
	CoCreateInstance(
		CLSID_FilterGraph,
		nil,
		CLSCTX_INPROC_SERVER,
		IID_IGraphBuilder,
		F_GraphBuilder
	);

	//CxgʒmEBhEZbgB
	F_GraphBuilder.QueryInterface(IMediaEventEx, F_MediaEventEx);
	F_MediaEventEx.SetNotifyWindow(Self.Handle, WM_GRAPH_NOTIFY, 0);
}
	//Ԏ擾̂
//	F_GraphBuilder.QueryInterface(IMediaPosition, F_MediaPosition);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
	F_Close;
end;

procedure TForm1.FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
	//}EXzC[ComboBoxTracko[Ă܂̂hB
	//̕KvȂ΃RgAEgB
	Handled := True;
end;

procedure TForm1.WMDisplayChange(var Msg: TMessage);
//TScreenMonitorsvpeBfBXvC̕ύXɒǐȂs̉̂߁B
begin
	Self.Monitor;
end;

procedure TForm1.MenuItem_FileExitClick(Sender: TObject);
begin
	Close;
end;

procedure TForm1.WMGraphNotify(var Msg: TMessage);
//Cxg
var
	li_EventCode   : Longint;
	li_Param1      : Longint;
	li_Param2      : Longint;
begin
	if (F_MediaEventEx = nil) then begin
Exit;
	end;

	// CxgSĎ擾
	while (Succeeded(F_MediaEventEx.GetEvent(li_EventCode, li_Param1, li_Param2, 0))) do begin
		if (MenuItem_Event.Checked) then begin
			debug_msg.ShowEvent(li_EventCode, li_Param1, li_Param2);
		end;

		try
			case (li_EventCode) of
				EC_COMPLETE
				:begin
					//ĐIɗ
					//AĐ
					if (ComboBox1.Items.Count = 0) then begin
						F_Close;
					end else begin
						if (ComboBox1.ItemIndex < ComboBox1.Items.Count -1) then begin
							ComboBox1.ItemIndex := ComboBox1.ItemIndex +1;
						end else begin
							ComboBox1.ItemIndex := 0;
						end;
						ComboBox1Select(nil);
					end;
				end;
			end;
		finally
			F_MediaEventEx.FreeEventParams(li_EventCode, li_Param1, li_Param2);
		end;
	end;
end;

procedure TForm1.Button_PlayPauseClick(Sender: TObject);
//Đ/ꎞ~
var
	l_MediaControl : IMediaControl;
	l_State        : TFilterState;
begin
	if (Assigned(F_GraphBuilder)) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.GetState(0, l_State);
		l_MediaControl := nil;
		if (l_State = State_Running) then begin
			Button_PauseClick(nil);
		end else begin
			Button_PlayClick(nil);
		end;
	end else begin
		Button_OpenClick(nil);
	end;
end;

procedure TForm1.Button_PlayClick(Sender: TObject);
//ĐJn
var
	l_MediaControl : IMediaControl;
begin
	if (Assigned(F_GraphBuilder)) then begin
		if (Assigned(F_VideoRenderer)) then begin
			F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
			l_MediaControl.Run;
			l_MediaControl := nil;
			Timer1.Enabled := True;
		end else begin
			Button_OpenClick(nil);
		end;
	end;
end;

procedure TForm1.Button_PauseClick(Sender: TObject);
//ꎞ~
var
	l_MediaControl : IMediaControl;
begin
	Timer1.Enabled := False;
	if (Assigned(F_GraphBuilder)) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Pause;
		l_MediaControl := nil;
		Timer1Timer(nil);
	end;
end;

procedure TForm1.Button_StopClick(Sender: TObject);
//~
var
	l_MediaControl : IMediaControl;
begin
	Timer1.Enabled := False;
	if (Assigned(F_GraphBuilder)) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Stop;

		//~łPauseƕςȂ
		//擪ɖ߂ɂIMediaPositiong
		F_MediaPosition.put_CurrentPosition(0);

		//ړł݈͌ʒũt[`悳ȂB
		//݈ʒũt[`悳邽߂Pause邢StopWhenReadyĂԁB
		l_MediaControl.StopWhenReady;
		l_MediaControl := nil;

		Timer1.Tag := 1;
		TrackBar1.Position := 0;
		Timer1.Tag := 0;
	end;
end;

procedure TForm1.Button_PlayBackClick(Sender: TObject);
//O
var
	li_Index : Integer;
begin
	if (ComboBox1.Items.Count > 0) then begin
		li_Index := ComboBox1.ItemIndex -1;
		if (li_Index < 0) then begin
			li_Index := ComboBox1.Items.Count -1;
		end;
		ComboBox1.ItemIndex := li_Index;
		ComboBox1Select(nil);
	end;
end;

procedure TForm1.Button_PlayNextClick(Sender: TObject);
//
var
	li_Index : Integer;
begin
	if (ComboBox1.Items.Count > 0) then begin
		li_Index := ComboBox1.ItemIndex +1;
		if (li_Index >= ComboBox1.Items.Count) then begin
			li_Index := 0;
		end;
		ComboBox1.ItemIndex := li_Index;
		ComboBox1Select(nil);
	end;
end;

procedure TForm1.F_Close;
var
	l_MediaControl : IMediaControl;
begin
	Timer1.Enabled     := False;
	Label_Size.Caption := '';
	Label_Time.Caption := '';

	if (F_GraphBuilder <> nil) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Stop;
		l_MediaControl := nil;
		DisconnectFilters(F_GraphBuilder);
	end;

	F_MediaPosition := nil;
	F_AudioRenderer := nil;
	F_VideoRenderer := nil;
	F_MediaEventEx  := nil;
	F_GraphBuilder  := nil;
end;

procedure TForm1.Button_OpenClick(Sender: TObject);
//J
var
	li_Count : Integer;
begin
	if (OpenDialog1.Execute) then begin
		li_Count := ComboBox1.Items.Count;
		ComboBox1.Items.AddStrings(OpenDialog1.Files);
		ComboBox1.ItemIndex := li_Count;
		ComboBox1Select(nil); //ĐJn
	end;
end;

procedure TForm1.Button_DeleteClick(Sender: TObject);
//XgĐ̃t@C폜
var
	li_Index : Integer;
begin
	li_Index := ComboBox1.ItemIndex;
	F_Close;
	ComboBox1.Items.Delete(li_Index);
	ComboBox1.ItemIndex := li_Index;
	ComboBox1Select(nil);
end;

procedure TForm1.Button_ClearClick(Sender: TObject);
//XgNA
begin
	F_Close;
	ComboBox1.Items.Clear;
end;

procedure TForm1.ComboBox1Select(Sender: TObject);
//t@CIĐ
var
	l_VideoWindow : IVideoWindow;
	l_BasicVideo  : IBasicVideo;
//amazonp
	li_Ret             : HResult;
	l_WMASFReader      : IBaseFilter;
	l_FileSourceFilter : IFileSourceFilter;
begin
	F_Close;

	if (ComboBox1.Items.Count = 0) then begin
		Exit;
	end;

	//GraphBuilder͂̓sx쐬ȂƍĐxύXĊJnłȂ
	//Ot쐬
	CoCreateInstance(
		CLSID_FilterGraph,
		nil,
		CLSCTX_INPROC_SERVER,
		IID_IGraphBuilder,
		F_GraphBuilder
	);

	//CxgʒmEBhEZbgB
	F_GraphBuilder.QueryInterface(IMediaEventEx, F_MediaEventEx);
	F_MediaEventEx.SetNotifyWindow(Self.Handle, WM_GRAPH_NOTIFY, 0);

	//rfI_[쐬 (VMR7)
	F_VideoRenderer := nil;
	CoCreateInstance(
		CLSID_VideoMixingRenderer,
		nil,
		CLSCTX_INPROC,
		IID_IBaseFilter,
		F_VideoRenderer
	);
	F_GraphBuilder.AddFilter(F_VideoRenderer, 'Video Renderer');

	if (ComboBox1.ItemIndex < 0) then begin
		ComboBox1.ItemIndex := 0;
	end;
	F_sFileName := ComboBox1.Items[ComboBox1.ItemIndex];
	//ǂݍ
	if (FAILED(F_GraphBuilder.RenderFile(PWideChar(F_sFileName), nil))) then begin
		//amazonmp3́ƎŝWM ASF ReadergB
		//WM ASF Reader͎ō쐬ăOtɒǉĂȂ΂ȂȂB
		//XɌqI[fBI_[(ftHĝ̂łĂ)ō쐬ăOtɒǉĂȂĂ͂ȂȂB
		CoCreateInstance(
			CLSID_WMAsfReader,
			nil,
			CLSCTX_INPROC_SERVER,
			IID_IBaseFilter,
			l_WMASFReader
		);
		//http://www.codeproject.com/KB/directx/saveimagefromstreamingurl.aspx
		F_GraphBuilder.AddFilter(l_WMASFReader, 'WM ASF Reader');
		l_WMASFReader.QueryInterface(IID_IFileSourceFilter, l_FileSourceFilter);
		l_FileSourceFilter.Load(PWideChar(F_sFileName), nil);
		l_FileSourceFilter := nil;

		CreateBaseFilter(F_AudioRenderer, CLSID_AudioRendererCategory, 'Default DirectSound Device');
		F_GraphBuilder.AddFilter(F_AudioRenderer, 'WM ASF Reader');
		li_Ret := ConnectFilters(F_GraphBuilder, l_WMASFReader, F_AudioRenderer);
		l_WMASFReader := nil;

		if (FAILED(li_Ret)) then begin
			ShowMessage(F_sFileName + #13'͊J܂');
			Button_DeleteClick(nil);
			Exit;
		end;
	end;

	//AXyNgێ
	//t@CǂݍłłȂfXNgbvtbVĂ܂B
	CheckBox_KeepAspectClick(nil);

	//plɃrfI\
	//t@CǂݍłłȂƕʃEBhEJĂ܂B
	F_GraphBuilder.QueryInterface(IVideoWindow, l_VideoWindow);
	l_VideoWindow.put_Owner(Panel_Video.Handle);
	l_VideoWindow.put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS);
	l_VideoWindow.put_MessageDrain(Panel_Video.Handle); //}EXbZ[WE悤ɂ
	l_VideoWindow.SetWindowForeground(OAFALSE);         //^XNo[tbV̂h
	l_VideoWindow := nil;
	//rfĨTCYplɍ킹B
	Panel_VideoResize(nil);

	//^Cgo[Ƀt@C\
	Caption := ExtractFileName(F_sFileName);

	//rfĨTCY擾
	F_GraphBuilder.QueryInterface(IBasicVideo, l_BasicVideo);
	F_iVideoWidth  := 0;
	F_iVideoHeight := 0;
	l_BasicVideo.get_VideoWidth (F_iVideoWidth);
	l_BasicVideo.get_VideoHeight(F_iVideoHeight);
	l_BasicVideo := nil;
	//t[[g擾
	if (F_iVideoWidth > 0) and (F_iVideoHeight > 0) then begin
		Label_Size.Caption := Format('%dx%d %sfps', [F_iVideoWidth, F_iVideoHeight, F_GetFrameRate]);
	end else begin
		Label_Size.Caption := '';
	end;

	//擾
	F_GraphBuilder.QueryInterface(IMediaPosition, F_MediaPosition);
	F_fDuration := 0;
	F_MediaPosition.get_Duration(F_fDuration); //̌CurrentPositionςĂ܂Ƃ
	TrackBar1.Max := Trunc(F_fDuration);

	//ĐxZbg
	MenuItem_Rate_10Click(nil);

	//擾CurrentPositionIɈړĂ܂Ƃ̂œɖ߂
	//F_MediaPosition.put_CurrentPosition(0);
	//Button_StopClick̒łĂ
	//ĐJn
	Button_StopClick(nil);
	Button_PlayClick(nil);
end;

procedure TForm1.Panel_VideoResize(Sender: TObject);
//rfĨTCYplɍ킹B
var
	l_VideoWindow : IVideoWindow;
begin
	if  (F_GraphBuilder  <> nil)
	and (F_VideoRenderer <> nil)
	then begin
		F_GraphBuilder.QueryInterface(IVideoWindow, l_VideoWindow);
{
		łƂ
		l_VideoWindow.put_Owner(Panel_Video.Handle);
		l_VideoWindow.put_WindowStyle(WS_CHILD or WS_CLIPSIBLINGS);
		l_VideoWindow.put_MessageDrain(OATRUE);
		l_VideoWindow.SetWindowForeground(OAFALSE);
}
		l_VideoWindow.SetWindowPosition(0, 0, Panel_Video.Width, Panel_Video.Height);
		l_VideoWindow := nil;
	end;
end;

procedure TForm1.Panel_VideoDblClick(Sender: TObject);
//tXN[[hB
//}`j^[ɑΉB
//̃EBhEGƉB
//ȂςƕʃEBhEŕ\Ă܂sB
var
	l_VideoWindow : IVideoWindow;
	lb_FullScreen : LongBool;
begin
	if  (F_GraphBuilder  <> nil)
	and (F_VideoRenderer <> nil)
	then begin
		F_GraphBuilder.QueryInterface(IVideoWindow, l_VideoWindow);
		l_VideoWindow.get_FullScreenMode(lb_FullScreen);
		l_VideoWindow.put_FullScreenMode(not(lb_FullScreen));
		l_VideoWindow := nil;
	end;
end;

procedure TForm1.CheckBox_KeepAspectClick(Sender: TObject);
//AXyNgێB
//IVMRAspectRatioControlłtH[OnResizeCxgŃrfI̕\̈
//mŗǂB
var
	l_VMRAspectRatioControl : IVMRAspectRatioControl;
begin
	if (Sender <> nil) then begin
		MenuItem_KeepAspect.Checked := not(MenuItem_KeepAspect.Checked);
		Button_KeepAspect.Down      := MenuItem_KeepAspect.Checked;
	end;

	if (F_VideoRenderer = nil) then begin
		Exit;
	end;

	F_VideoRenderer.QueryInterface(IVMRAspectRatioControl, l_VMRAspectRatioControl);
	if (l_VMRAspectRatioControl <> nil) then begin
		if (MenuItem_KeepAspect.Checked) then begin
			//AXyNgێB
			l_VMRAspectRatioControl.SetAspectRatioMode(VMR_ARMODE_LETTER_BOX);
		end else begin
			//AXyNgρB
			l_VMRAspectRatioControl.SetAspectRatioMode(VMR_ARMODE_NONE);
		end;
		l_VMRAspectRatioControl := nil;
	end;
end;

//V[No[ ---
procedure TForm1.Timer1Timer(Sender: TObject);
//݈ʒu\B
	function FloatToTime(fTime : TRefTime) : String;
	var
		li_Time, li_Hour, li_Min, li_Sec : Integer;
	begin
		li_Time := Trunc(fTime);
		li_Hour := li_Time div 60 div 60;
		li_Min  := li_Time div 60 mod 60;
		li_Sec  := li_Time mod 60;
//		Result  := Format('%d:%.2d:%.2d.%.3d', [li_Hour, li_Min, li_Sec, Trunc(Frac(fTime) * 1000)]);
		Result  := Format('%d:%.2d:%.2d', [li_Hour, li_Min, li_Sec]);
	end;
	function IsDragThumb: Boolean;
	//gbNo[̃XC_[GĂ邩B
	//ۂ̓gbNo[}EXLv`Ă邩B
	begin
		if not(BOOL(Hi(GetAsyncKeyState(VK_LBUTTON)))) then begin
			Result := False;
			Exit;
		end;
		Result := (GetCapture = TrackBar1.Handle);
	end;
var
	lf_Pos : Double;
begin
	if (Assigned(F_GraphBuilder)) then begin
		Timer1.Tag := 1;

		F_MediaPosition.get_CurrentPosition(lf_Pos);
		Label_Time.Caption := Format('%s/%s', [FloatToTime(lf_Pos), FloatToTime(F_fDuration)]);

		if not(IsDragThumb) then begin
			//gbNo[̃XC_[GĂȂXC_[݈ʒuɈړB
			TrackBar1.Position := Trunc(lf_Pos);
		end;

		Timer1.Tag := 0;
	end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
//gbNo[ړB
var
	l_MediaPosition : IMediaPosition;
begin
	if (Timer1.Tag <> 0) then begin
		Exit;
	end;

	if (Assigned(F_GraphBuilder)) then begin
		if not(BOOL(Hi(GetAsyncKeyState(VK_LBUTTON)))) then begin
			F_GraphBuilder.QueryInterface(IMediaPosition, l_MediaPosition);
			l_MediaPosition.put_CurrentPosition(TrackBar1.Position);
			l_MediaPosition := nil;
		end;
	end;
end;
//--------


//--------
procedure TForm1.Button_CaptureClick(Sender: TObject);
//rfIfrbg}bv擾B
var
	lf_Pos : Double;
begin
	if (F_MediaPosition = nil)
	or (F_iVideoWidth  <= 0)
	or (F_iVideoHeight <= 0)
	then begin
		Exit;
	end;

	//ݍĐ̃_[Ƃ͕ʂ̃_[iOtʁj擾B
	Button_Capture.Enabled := False;
	try
		F_MediaPosition.get_CurrentPosition(lf_Pos);
		if (capt.Capture(F_sFileName, lf_Pos)) then begin
			capt.CopyImage;
		end;
	finally
		Button_Capture.Enabled := True;
	end;
end;
//--------


//--- t[[g ---
function _Round(fNum: Double): Integer;
//fNumľܓĕԂB
//DelphĩwvRs[B
begin
	if (fNum >= 0) then begin
		Result := Trunc(fNum + 0.5);
	end else begin
		Result := Trunc(fNum - 0.5);
	end;
end;

function TForm1.F_GetFrameRate : String;
var
	li_Time     : Int64;
	l_EnumPins  : IEnumPins;
	l_Pin       : IPin;
	l_PinInfo   : TPinInfo;
	l_MediaType : TAMMediaType;
begin
	Result := '-';
	F_fAvgTimePerFrame := 0;

	if (F_VideoRenderer = nil) then begin
		Exit;
	end;

	F_VideoRenderer.EnumPins(l_EnumPins);
	try
		while(l_EnumPins.Next(1, l_Pin, nil) = S_OK) do begin
			l_Pin.QueryPinInfo(l_PinInfo);
			try
				if (l_PinInfo.dir = PINDIR_INPUT) then begin
					//
					l_Pin.ConnectionMediaType(l_MediaType);
					try
						if (IsEqualGUID(l_MediaType.majortype,  MEDIATYPE_Video)) then begin
							if (IsEqualGUID(l_MediaType.formattype, FORMAT_VideoInfo)) then begin
								//VIDEOINFOHEADER
								li_Time := PVideoInfoHeader(l_MediaType.pbFormat)^.AvgTimePerFrame;
							end else if (IsEqualGUID(l_MediaType.formattype, FORMAT_VideoInfo2)) then begin
								//VIDEOINFOHEADER2
								li_Time := PVideoInfoHeader2(l_MediaType.pbFormat)^.AvgTimePerFrame;
							end else if (IsEqualGUID(l_MediaType.formattype, FORMAT_MPEGVideo)) then begin
								//MPEG1VIDEOINFO
								li_Time := PMpeg1VideoInfo(l_MediaType.pbFormat)^.hdr.AvgTimePerFrame;
							end else if (IsEqualGUID(l_MediaType.formattype, FORMAT_MPEG2Video)) then begin
								//MPEG2VIDEOINFO
								li_Time := PMpeg2VideoInfo(l_MediaType.pbFormat)^.hdr.AvgTimePerFrame;
							end else begin
								li_Time := 0;
							end;
							if (li_Time <> 0) then begin
								F_fAvgTimePerFrame := li_Time / UNITS;
//debug_msg.ShowDbg([F_fAvgTimePerFrame]);
								Result := Format('%g', [_Round(100 / F_fAvgTimePerFrame) / 100]);
							end;
							Break;
						end;
					finally
						FreeMediaType(@l_MediaType);
					end;
				end;
			finally
				if (l_PinInfo.pFilter <> nil) then begin
					l_PinInfo.pFilter := nil;
				end;
				l_Pin := nil;
			end;
		end;
	finally
		if (l_EnumPins <> nil) then begin
			l_EnumPins := nil;
		end;
	end;
end;

//--- t[ړ ---
function TForm1.F_CanStep(iStep: Integer): Boolean;
var
	l_VideoFrameStep : IVideoFrameStep;
begin
	Result := False;
	if (F_GraphBuilder <> nil) then
	begin
		F_GraphBuilder.QueryInterface(IVideoFrameStep, l_VideoFrameStep);
		if (l_VideoFrameStep <> nil) then
		begin
			Result := (l_VideoFrameStep.CanStep(iStep, nil) = S_OK);
			l_VideoFrameStep := nil;
		end;
	end;
end;

procedure TForm1.Button_FrameBackClick(Sender: TObject);
//Õt[B
var
	lf_Pos : TRefTime;
begin
	Button_PauseClick(nil);
	if (F_fAvgTimePerFrame = 0) then begin
		//F_fAvgTimePerFrame0̏ꍇb29.97fps̃rfIłƂB
		F_fAvgTimePerFrame := 1 / 29.97;
	end;
	F_MediaPosition.get_CurrentPosition(lf_Pos);
	F_MediaPosition.put_CurrentPosition(lf_Pos - F_fAvgTimePerFrame);
end;

procedure TForm1.Button_FrameNextClick(Sender: TObject);
//̃t[B
var
  l_VideoFrameStep : IVideoFrameStep;
  lb_Step          : Boolean;
  lf_Pos           : TRefTime;
begin
	lb_Step := False;
	if (F_CanStep(1)) then
	begin
		F_GraphBuilder.QueryInterface(IVideoFrameStep, l_VideoFrameStep);
		if (l_VideoFrameStep <> nil) then
		begin
			lb_Step := (l_VideoFrameStep.Step(1, nil) = S_OK);
			l_VideoFrameStep := nil;
		end;
	end;
	if (lb_Step) then
	begin
		//t[ړȂ̂ňȉ̏΂
		Exit;
	end;

	//ł܂Ȃꍇ
	Button_PauseClick(nil);
  if (F_fAvgTimePerFrame = 0) then begin
    //F_fAvgTimePerFrame0̏ꍇb29.97fps̃rfIłƂB
    F_fAvgTimePerFrame := 1 / 29.97;
  end;
  F_MediaPosition.get_CurrentPosition(lf_Pos);
  F_MediaPosition.put_CurrentPosition(lf_Pos + F_fAvgTimePerFrame);
end;
{
procedure TForm1.Button_FrameNextClick(Sender: TObject);
//̃t[B
var
	lf_Pos : TRefTime;
begin
	Button_PauseClick(nil);
	if (F_fAvgTimePerFrame = 0) then begin
		//F_fAvgTimePerFrame0̏ꍇb29.97fps̃rfIłƂB
		F_fAvgTimePerFrame := 1 / 29.97;
	end;
	F_MediaPosition.get_CurrentPosition(lf_Pos);
	F_MediaPosition.put_CurrentPosition(lf_Pos + F_fAvgTimePerFrame);
end;
}
//--------

//--- ĐxύX ---
procedure TForm1.MenuItem_Rate_10Click(Sender: TObject);
//wmv,wma,amazonmp3͍Đx̕ύX͂łȂ
var
//	li_Ret  : HResult;
//	ls_Err  : String;
//	ls_Msg  : String;
	lf_Rate : Double;
	i       : Integer;
begin
	if (Sender is TMenuItem) then begin
		TMenuItem(Sender).Checked := True;
	end;

	if (F_MediaPosition = nil) then begin
		Exit;
	end;

	lf_Rate := 1.0;
	for i := 0 to MenuItem_Rate.Count -1 do begin
		if (MenuItem_Rate.Items[i].Checked) then begin
			lf_Rate := StrToFloatDef(MenuItem_Rate.Items[i].Caption, 1.0);
			Break;
		end;
	end;

	{li_Ret :=} F_MediaPosition.put_Rate(lf_Rate);
{
	case li_Ret of
		S_OK
		:begin
			ls_Err := 'S_OK';
			ls_Msg := 'ĐxύX'
		end;
		E_NOTIMPL
		:begin
			ls_Err := 'E_NOTIMPL';
			ls_Msg :=	'w肳ꂽ@\Ă܂B';
		end;
		E_INVALIDARG
		:begin
			ls_Err := 'E_INVALIDARG';
			ls_Msg := 'w肵[ǵA0 ܂͕̒lB';
		end;
		E_POINTER
		:begin
			ls_Err := 'E_POINTER';
			ls_Msg := 'NULL |C^B';
		end;
		VFW_E_UNSUPPORTED_AUDIO:
		begin
			ls_Err := 'VFW_E_UNSUPPORTED_AUDIO';
			ls_Msg := 'I[fBI foCX邢̓tB^̃[gT|[gĂȂB';
		end;
	end;

	debug_msg.ShowDbg(Format('%.1f 0x%.8x %s %s', [lf_Rate, li_Ret, ls_Err, ls_Msg]));
}
end;
//--------


end.
